// srvrview.cpp : implementation of the CGIFServerView class
//

#include "stdafx.h"
#include "gifserv.h"

#include "srvrdoc.h"
#include "srvrview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGIFServerView

IMPLEMENT_DYNCREATE(CGIFServerView, CView)

BEGIN_MESSAGE_MAP(CGIFServerView, CView)
	//{{AFX_MSG_MAP(CGIFServerView)
	ON_COMMAND(ID_CANCEL_EDIT_SRVR, OnCancelEditSrvr)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGIFServerView construction/destruction

CGIFServerView::CGIFServerView()
{
	//SetScrollSizes(MM_TEXT, CSize(0,0));
}

CGIFServerView::~CGIFServerView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CGIFServerView drawing

void CGIFServerView::OnDraw(CDC* pDC)
{
	CGIFServerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	RECT clientRect;
	GetClientRect(&clientRect);

	pDoc->draw(*pDC, clientRect);
}

/////////////////////////////////////////////////////////////////////////////
// CGIFServerView printing

BOOL CGIFServerView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CGIFServerView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CGIFServerView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// OLE Server support

// The following command handler provides the standard keyboard
//  user interface to cancel an in-place editing session.  Here,
//  the server (not the container) causes the deactivation.
void CGIFServerView::OnCancelEditSrvr()
{
	GetDocument()->OnDeactivateUI(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// CGIFServerView diagnostics

#ifdef _DEBUG
void CGIFServerView::AssertValid() const
{
	CView::AssertValid();
}

void CGIFServerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGIFServerDoc* CGIFServerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGIFServerDoc)));
	return (CGIFServerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGIFServerView message handlers

void CGIFServerView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CGIFServerDoc* pDoc = GetDocument();

	CView::OnPrepareDC(pDC, pInfo);
											   
#if 0
	pDC->SetMapMode(MM_ANISOTROPIC);
	CSize sizeDoc = pDoc->getDocSize();
	sizeDoc.cy = -sizeDoc.cy;
	pDC->SetWindowExt(sizeDoc);

	CSize sizeNum, sizeDenom;
	pDoc->GetZoomFactor(&sizeNum, &sizeDenom);

	int xLogPixPerInch = pDC->GetDeviceCaps(LOGPIXELSX);
	int yLogPixPerInch = pDC->GetDeviceCaps(LOGPIXELSY);

	long xExt = (long)sizeDoc.cx * xLogPixPerInch * sizeNum.cx;
	xExt /= 100 * (long)sizeDenom.cx;
	long yExt = (long)sizeDoc.cy * yLogPixPerInch * sizeNum.cy;
	yExt /= 100 * (long)sizeDenom.cy;
	pDC->SetViewportExt((int)xExt, (int)-yExt);
#endif
}


void CGIFServerView::SetScrollInfo()
{
	//CClientDC dc(NULL);
	//OnPrepareDC(&dc);
	//CSize sizeDoc = GetDocument()->getDocSize();
	//dc.LPtoDP(&sizeDoc);
	//SetScrollSizes(MM_TEXT, sizeDoc);
}

void CGIFServerView::OnInitialUpdate() 
{
	SetScrollInfo();
	CView::OnInitialUpdate();
}

void CGIFServerView::OnSize(UINT nType, int cx, int cy) 
{
	SetScrollInfo();
	CView::OnSize(nType, cx, cy);
}
